variables:
  DOCKER_HOST: tcp://docker:2375
  DOCKER_DRIVER: overlay2
  DOCKER_TLS_CERTDIR: ""

stages:
  - build
  - deploy

app:
  stage: build
  image: docker
  services:
    - name: docker:dind
      alias: docker
      command: [ "--tls=false" ]
  script:
    - apk add --no-cache docker-compose make
    - docker login $CI_REGISTRY -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD
    - docker build -t ${CI_REGISTRY_IMAGE}:${CI_COMMIT_REF_NAME} -f docker/app/Dockerfile .
    - docker push ${CI_REGISTRY_IMAGE}:${CI_COMMIT_REF_NAME}
  only:
    - tags
    - develop
    - main

Deploy production:
  stage: deploy
  image: alpine:3.7
  before_script:
    - apk add --no-cache curl
    - curl -LO https://storage.googleapis.com/kubernetes-release/release/$(curl -s https://storage.googleapis.com/kubernetes-release/release/stable.txt)/bin/linux/amd64/kubectl
    - chmod +x ./kubectl
  environment:
    name: ledius-production
    kubernetes:
      namespace: ledius-production
  script:
    - echo $KUBECONFIG
    - export KUBECONFIG=$KUBECONFIG
    - ./kubectl apply -f .kube/production
    - ./kubectl rollout restart deployment fund-deployment
  only:
    - main

Deploy develop:
  stage: deploy
  image: alpine:3.7
  before_script:
    - apk add --no-cache curl
    - curl -LO https://storage.googleapis.com/kubernetes-release/release/$(curl -s https://storage.googleapis.com/kubernetes-release/release/stable.txt)/bin/linux/amd64/kubectl
    - chmod +x ./kubectl
  environment:
    name: ledius-develop
    kubernetes:
      namespace: ledius-develop
  script:
    - echo $KUBECONFIG
    - export KUBECONFIG=$KUBECONFIG
    - ./kubectl apply -f .kube/develop
    - ./kubectl rollout restart deployment fund-deployment
  only:
    - develop
